{$G+}
Unit Lite;
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Interface

Var
  Key: array[0..127] of Boolean;
  Buffer: array[0..4] of Word;

  Procedure Init320x200;
  Procedure Init80x25;
  Procedure WaitRetrace;

  Procedure InitBuffers;
  Procedure ShutdownBuffers;

  Procedure GetPal(Color:Byte; Var R,G,B:Byte);
  Procedure SetPal(Color:Byte; R,G,B:Byte);

  Procedure LoadGRPage(JmenoSouboru:string;Pozice:LongInt);
  Procedure LoadBmpFile(JmenoSouboru: string; pozice: LongInt; StartColor: Byte);
  Procedure LoadBlok(x1,y1,x2,y2,x3,y3,BufferTo: Word);
  Procedure LoadBlokM(x1,y1,x2,y2,x3,y3,BufferTo: Word);
  Procedure LoadBitMap(X,Y: Word; BufferTo: Word);
  Procedure LoadBitMapM(X,Y: Word; BufferTo: Word);

  Function  ReadPixel(X,Y,Buffer:Word): Byte;
  Procedure WritePixel(X:Word;Y,Color:Byte;Buffer:Word);
  Procedure Blok(x1,y1,x2,y2,Color,Buffer:Word);
  Procedure Ramecek(X1,Y1,X2,Y2:Word;Color:Byte;Buffer:Word);
  Procedure WriteBlok(x1,y1,x2,y2,x3,y3,BufferFrom,BufferTo: Word);
  Procedure WriteSprite(x1,y1,x2,y2,x3,y3,BufferFrom,BufferTo: Word);
  Procedure LoadDefaultFont(x1,y1,Color,BufferTo: Word);
  Procedure WriteNumber(FontBuffer,FontX,FontY,FontDelka,FontVyska,mezera,x,y:Word;Cislo:Longint;BufferTo:Word);
  Procedure WriteText(FontBuffer,FontX,FontY,FontDelka,FontVyska,mezera,x,y:Word;retezec:string;BufferTo:Word);

  Procedure FlipPage(BufferFrom,BufferTo: Word);
  Procedure ClearPage(Buffer:Word);

  Procedure InitMapBuffers(Velikost: Word);
  Procedure ShutdownMapBuffers;
  Procedure LoadMapFile(soubor:string; pozice:Longint);
  Procedure SetMapByte(MapOffset:Word;bajt:Byte);
  Function  GetMapByte(MapOffset:Word): Byte;

  Procedure InitKeyboard;
  Procedure ShutdownKeyboard;

  Function  DetekujXms: Word;
  Procedure GetSizeXms(var celkemXMS,blokXMS: Word);
  Function  AlokujXms(kolik: Word): word;
  Procedure UvolniXms(handle: Word);
  Procedure MoveToXMS(Handle: Word; XMSOffset: LongInt; Var Source; BlockLength: LongInt);
  Procedure MoveFromXMS(Handle: Word; XMSOffset: LongInt; Var Dest; BlockLength: LongInt);

  Procedure InitSB;
  Procedure ShutdownSB;
  Procedure SBPlayRaw(Cislo:Byte);

  Procedure InitTimer;
  Procedure ShutdownTimer;

  Procedure Wait(ms: Word);
  Procedure Sound(Hertz: Word);
  Procedure Silence;
  Procedure Stopky_Start;
  Procedure Stopky_Stop;
  Function  Stopky_GetNumber: LongInt;
  Function  FPS2s: Boolean;
  Procedure Start_LoadSymbol(X,Y:Word;BackColor,FrontColor:Byte);
  Procedure Stop_LoadSymbol;

  Procedure InitRawBuffers;
  Procedure ShutdownRawBuffers;
  Procedure LoadRAWFile(filename: String;Pozice:LongInt;N:Byte);
  Procedure PlayRaw(Cislo:Byte);

  Procedure LoadSNDFile(Filename:String;Pozice:LongInt);
  Procedure PlaySound(Sample:Byte);
  Procedure StopPlay;

  Procedure InitGM;
  Procedure ShutdownGM;
  Procedure LoadMELFile(Filename:String;Pozice:LongInt);
  Procedure StartGMPlay(Temp,Vol:Byte;Start,Finish:Word;Rep:Boolean);
  Procedure StopGMPlay;
  Procedure SetMelodyTempo(Temp: Byte);
  Procedure SetKanalVolume(Kan,Vol: Byte);
  Procedure JumpToMelodyRepeat;

  Procedure SetNastroj(Kanal,Cislo:byte);
  Procedure SetBalance(Kanal,Poloha:byte);
  Procedure NotaOn(Kanal,Nota,Hlasitost:byte);
  Procedure NotaOff(Kanal,Nota,Hlasitost:byte);


{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Implementation
{$L C:\SOURCES\STORE1\ENGINE\blok.obj}
{$L C:\SOURCES\STORE1\ENGINE\writeblk.obj}
{$L C:\SOURCES\STORE1\ENGINE\flippage.obj}
{$L C:\SOURCES\STORE1\ENGINE\clearpag.obj}

Uses DOS;

Type
  TRGB= Record
          R: Byte;
          G: Byte;
          B: Byte;
        End;

  TSample = Record
              Handle: Word;
              Delka: LongInt;
              Pocitadlo: Word;
            End;

  TMapa = Record
            MapFile: File;
            Size: Word;
            MapBuffer: Word;
            MapBufferP: Pointer;
            DelkaRLE: Word;
          End;

  TMelody1 = Record
               Nastroj: Byte;
               Balance: Byte;
               DefaultOktava: Byte;
               Nota: Byte;
               Volume: Byte;
               Pos: Word;
               NotaHraje: Boolean;
               NotaCounter: Byte;
               FIFO: array[1..2] of Byte;
             End;

  TMelody = Record
              DataSeg: Word;
              DataPoint: Pointer;
              Kanal: array[0..3] of TMelody1;
              Delka: LongInt;
              Tempo: Word;
              Delay: Word;
              DelayCounter: Word;
              Opakovat: Boolean;
              Repetice: LongInt;
              Start: Word;
              Finish: Word;
            End;

  TLoadSymbol = Record
                  X: Word;
                  Y: Word;
                  BackColor: Byte;
                  FrontColor: Byte;
                  OnScreen: Boolean;
                  TimeCounter: Word;
                  FrameCounter: Byte;
                End;

  XMSParamBlock= Record
                   Length: LongInt;
                   SHandle: Word;
                   SOffset: Array[1..2] Of Word;
                   DHandle: Word;
                   DOffset: Array[1..2] Of Word;
                 End;

  TBMPHeader = Record
                 Id: Word;
                 Velikost: LongInt;
                 Reserved: LongInt;
                 DataOffset: LongInt;
                 HeaderSize: LongInt;
                 RozsahX: LongInt;
                 RozsahY: LongInt;
                 BitPlanes: Word;
                 BPP: Word;
                 Komprese: LongInt;
                 ImageSize: LongInt;
                 HorizontalRes: LongInt;
                 VerticalRes: LongInt;
                 Colors: LongInt;
                 ImportantColors: LongInt;
               End;

  TBmpRGB = Record
            B: Byte;
            G: Byte;
            R: Byte;
            Reserved: Byte;
          End;

  TBMP = Record
           Header: TBMPHeader;
           Palette: array[0..15] of TBmpRGB;
           DataByte: Byte;
         End;

Const
  DefaultFont: array[0..124] of Byte =
  (119,157,239,253,241,255,227,24,198,16,132,72,31,250,17,247,175,242,6,49,
   140,97,8,196,145,143,157,239,193,209,251,163,8,197,222,119,159,249,67,121,
   140,99,24,19,144,173,99,234,249,196,148,35,56,194,113,9,35,248,197,208,
   124,124,72,198,49,143,192,64,6,49,138,162,47,144,2,140,98,69,16,31,
   249,34,170,168,136,249,0,135,17,81,39,192,64,65,196,247,143,247,125,206,
   155,2,20,194,1,140,107,71,59,238,240,156,252,146,1,8,98,72,133,223,
   255,131,231,33,206);

   MaxRawu = 49;

   DMA8reg : array[0..2] of byte = ($a,$b,$c);
   DMA16reg : array[0..2] of byte = ($d4,$d6,$d8);
   DMAOfs : array[0..7] of byte = (0,2,4,6,$c0,$c4,$c8,$cc);
   DMAVel : array[0..7] of byte = (1,3,5,7,$c2,$c6,$ca,$ce);
   DMAstr : array[0..7] of byte = ($87,$83,$81,$82,$89,$8a,$8b,$8f);
   INTvec : array[0..15] of byte = (8,9,10,11,12,13,14,15,$70,$71,$72,$73,$74,$75,$76,$77);


Var
  F: File;
  Bmp: TBMP;
  Map: TMapa;
  Melody: TMelody;

  GrafikaSeg: Word;             GrafikaP: Pointer;
  Barvy4Seg: Word;              Barvy4P: Pointer;
  PaletaSeg: Word;              PaletaP: Pointer;

  RLESeg: Word;
  RLEP: Pointer;
  RLEdelka: Word;

  Barva: array[0..15] of TRGB;
  CisloStranky: Byte;

  BufferP: array[0..3] of Pointer;
  Buffer2: Pointer;
  BufferSeg2: Word;

  b: array[0..7] of Byte;

  PressedKey: Byte;
  BIOSKeyboardHandler: Procedure;

  BIOSTimerHandler: Procedure;
  clock_ticks,counter: longint;
  StopkyTics: LongInt;
  StopkyActive: Boolean;

  SoundDataSeg: Word;     SoundDataP: Pointer;
  ZvukTabSeg: Word;       ZvukTabP: Pointer;

  xmsAdr:longint;
  xmsVersion,ovlXmsVersion,hmaDetect: Word;
  xmsCelkem,xmsMaxBlok: Word;
  xmsChyba: Byte;
  xmsCelkemPotreba: Word;
  xmsBlokPotreba: Word;
  XMSError: Boolean;

  PrehravanyZvuk: Byte;
  PocetRawu: Byte;
  RawHraje: Boolean;
  Sample: array[0..MaxRawu] of TSample;
  OffsetSpeakeru: Word;

  PrehravatZvuk: Boolean;
  CisloZvuku: Byte;
  PosuvZ: Word;

  delaycounter: Word;
  waiting: Boolean;
  player: Byte;
  fps_helper: Byte;

  GMAdr: Word;
  GMHraje: Boolean;

  LoadSymbol: TLoadSymbol;

  IRQ,DMA8,DMA16 : byte;
  Adr : word;
  Typ : byte;
  SBbuffer : pointer;
  SBBufferSeg: Word;
  StaraSBObsluha : pointer;
  LinearAdr : longint;
  Stranka,OfsStranky : word;
  AktCast : byte;
  SBOffsetMIN: Word;
  SBOffsetMAX: Word;
  HrajeLongRaw: Boolean;
  DelkaZbytku: LongInt;
  AktPos: LongInt;
  CisloRawu: Byte;

{SECTION GRAPHICS XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Procedure Init320x200; Assembler;
Asm
  Mov AH, 00h
  Mov AL, 13h
  Int 10h
End;


Procedure Init80x25; Assembler;
Asm
  Mov AH, 00h
  Mov AL, 03h
  Int 10h
End;


Procedure WaitRetrace; Assembler;
Asm
    Mov dx,3DAh
@l1:
    In al,dx
    And al,08h
    Jnz @l1
@l2:
    In al,dx
    And al,08h
    Jz  @l2
End;


Procedure InitBuffers;
Var I,x: Word;
Begin
  GetMem(BufferP[0],32768); Buffer[0]:=Seg(BufferP[0]^);
  For x:=0 to 32767 do mem[Buffer[0]:x]:=0;

  For I:=1 to 3 do
  Begin
    GetMem(BufferP[I],64000); Buffer[I]:=Seg(BufferP[I]^);
    For x:=0 to 63999 do mem[Buffer[I]:x]:=0;
  End;

  Buffer[4]:=$A000;
  GetMem(Buffer2,2000); BufferSeg2:=Seg(Buffer2^);
  GetMem(GrafikaP,8000); GrafikaSeg:=Seg(GrafikaP^);
  GetMem(Barvy4P,1008); Barvy4Seg:=Seg(Barvy4P^);
  GetMem(PaletaP,48); PaletaSeg:=Seg(PaletaP^);
  GetMem(RLEP,9056); RLESeg:=Seg(RLEP^);

  For I:=0 to 1999 do mem[BufferSeg2:I]:=0;
  For I:=0 to 7999 do mem[GrafikaSeg:I]:=0;
  For I:=0 to 1007 do mem[Barvy4Seg:I]:=0;
  For I:=0 to 47 do mem[PaletaSeg:I]:=0;
  For I:=0 to 9055 do mem[RLESeg:I]:=0;

End;


Procedure ShutdownBuffers;
Var I: Byte;
Begin
  FreeMem(BufferP[0],32768);
  For I:=1 to 3 do FreeMem(BufferP[I],64000);
  FreeMem(Buffer2,2000);
  FreeMem(GrafikaP,8000);
  FreeMem(Barvy4P,1008);
  FreeMem(PaletaP,48);
  FreeMem(RLEP,9056);
End;


Function Bin2Dec(b7,b6,b5,b4,b3,b2,b1,b0: Byte): Byte;
Var I: Byte;
Begin
  I:=0;
  If b7=1 then Inc(I,128);
  If b6=1 then Inc(I,64);
  If b5=1 then Inc(I,32);
  If b4=1 then Inc(I,16);
  If b3=1 then Inc(I,8);
  If b2=1 then Inc(I,4);
  If b1=1 then Inc(I,2);
  If b0=1 then Inc(I,1);
  Bin2Dec:=I;
End;


Procedure Dec2Bin(DCnum:Byte);
Var I: Byte;
Begin
  For I:=0 to 7 do b[I]:=(DCnum AND (1 SHL I)) SHR I;
End;


Procedure GetPal(Color:Byte; Var R,G,B:Byte);
Begin
   Port[$3c7]:=Color;
   R:=Port[$3c9];
   G:=Port[$3c9];
   B:=Port[$3c9];
End;


Procedure SetPal(Color:Byte; R,G,B:Byte);
Begin
   Port[$3c8]:=Color;
   Port[$3c9]:=R;
   Port[$3c9]:=G;
   Port[$3c9]:=B;
End;


Function GetHDDByte: Byte;
Var ReadByte: Byte;
Begin
  BlockRead(F,ReadByte,1);
  GetHDDByte:=ReadByte;
End;


Procedure RLEDekompress;
Var
  WritedBA: Byte; {znak A}
  WritedBB: Byte; {je-li komprese tak stejny jako znak A}
  WritedBC: Byte; {pocet kolikrat tam je znak A }
  I,A,posun: Word;
Begin
    I:=0; posun:=0;
    While not (posun=RLEDelka) do
    Begin

      WritedBA:=GetHDDByte;                  {nacteme A}
      Inc(posun);
      If posun=RLEDelka then                 {je-li konec zapsat a BREAK}
      Begin
        mem[RLESeg:I]:=WritedBA;
        Break;
      End;

      WritedBB:=GetHDDByte;                {nacteme B}
      Inc(posun);

      If posun=RLEDelka then               {je-li konec zapsat a BREAK}
      Begin
        mem[RLESeg:I]:=WritedBA;
        mem[RLESeg:I+1]:=WritedBB;
        Break;
      End;

      If WritedBA=WritedBB then  {jsou-li dva stejne tzn. nasleduje pocet}
      Begin
        WritedBC:=GetHDDByte;    {muzeme nacist pocet}
        Inc(posun);
        For A:=1 to WritedBC do
        Begin
          mem[RLESeg:I]:=WritedBA; {zapisujeme WritedBC krat}
          Inc(I);
        End;
      End else {jsou dva ruzne}
      Begin
        mem[RLESeg:I]:=WritedBA;   {zapisme jeden a navrat nahoru}
        Inc(I);
        Dec(posun);         {posuneme index o jednu nazpet}
        Seek(F,FilePos(F)-1);
      End;

    End; {While End}
End;


Procedure MovArraysTo3;
Var I,A: Word;
Begin
  A:=0;
  For I:=0 to 7999 do Begin mem[GrafikaSeg:I]:=mem[RLESeg:A]; Inc(A); End;
  For I:=0 to 999 do Begin mem[Barvy4Seg:I]:=mem[RLESeg:A]; Inc(A); End;
  For I:=0 to 47 do Begin mem[PaletaSeg:I]:=mem[RLESeg:A]; Inc(A); End;
  CisloStranky:=mem[RLESeg:9048];
End;


Procedure Rozkodovat;
Var Offset32,Offset2,Xa,Ya,X1,Y1,x,y,A,I: Word;
Begin
  {Rozkodovani grafiky 8000B}
  A:=0; I:=0;
  Repeat
    Dec2Bin(mem[GrafikaSeg:I]);
    mem[Buffer[0]:A+0]:=Bin2Dec(0,0,0,0,0,0,b[1],b[0]);
    mem[Buffer[0]:A+1]:=Bin2Dec(0,0,0,0,0,0,b[3],b[2]);
    mem[Buffer[0]:A+2]:=Bin2Dec(0,0,0,0,0,0,b[5],b[4]);
    mem[Buffer[0]:A+3]:=Bin2Dec(0,0,0,0,0,0,b[7],b[6]);
    Inc(A,4);
    Inc(I);
  Until I=8000;
  {Rozkodovani barvy4 2000B}
  A:=0; I:=0;
  Repeat
    Dec2Bin(mem[Barvy4Seg:I]);
    mem[BufferSeg2:A+0]:=Bin2Dec(0,0,0,0,b[3],b[2],b[1],b[0]);
    mem[BufferSeg2:A+1]:=Bin2Dec(0,0,0,0,b[7],b[6],b[5],b[4]);
    Inc(A,2);
    Inc(I);
  Until I=1000;
  {Nahravani palety RGB ze souboru}
  A:=0;
  For I:=0 to 15 do
  Begin
    Barva[I].R:=mem[PaletaSeg:A+0];
    Barva[I].G:=mem[PaletaSeg:A+1];
    Barva[I].B:=mem[PaletaSeg:A+2];
    Inc(A,3);
  End;
  {Nastaveni palety RGB - nutny graficky rezim}
  For I:=0 to 15 do SetPal(CisloStranky*16+I,Barva[I].R,Barva[I].G,Barva[I].B);

  {Nastaveni spravnych barev 160x200 po krocich 8x8}
  For Ya:=0 to 24 do
  For Xa:=0 to 19 do
  Begin
    For y:=0 to 7 do
    For x:=0 to 7 do
    Begin
      X1:=Trunc((Xa*8+x)/8);
      Y1:=Trunc((Ya*8+y)/8);
      Offset2:=(Y1*20+X1)*4;
      Offset32:=((Ya*8+y)*160)+(Xa*8+x);
      Case mem[Buffer[0]:Offset32] of
        0: Begin
             If mem[BufferSeg2:Offset2+0]>0
             then mem[Buffer[0]:Offset32]:=mem[BufferSeg2:Offset2+0]+(CisloStranky*16)
             else mem[Buffer[0]:Offset32]:=0;
           End;
        1: Begin
             If mem[BufferSeg2:Offset2+1]>0
             then mem[Buffer[0]:Offset32]:=mem[BufferSeg2:Offset2+1]+(CisloStranky*16)
             else mem[Buffer[0]:Offset32]:=0;
           End;
        2: Begin
             If mem[BufferSeg2:Offset2+2]>0
             then mem[Buffer[0]:Offset32]:=mem[BufferSeg2:Offset2+2]+(CisloStranky*16)
             else mem[Buffer[0]:Offset32]:=0;
           End;
        3: Begin
             If mem[BufferSeg2:Offset2+3]>0
             then mem[Buffer[0]:Offset32]:=mem[BufferSeg2:Offset2+3]+(CisloStranky*16)
             else mem[Buffer[0]:Offset32]:=0;
           End;
      End; {Case End}
    End;
  End;
End;


Procedure LoadGRPage(JmenoSouboru:string;Pozice:LongInt);
Var I: Word;
    WritedByte: Byte;
Begin
  Assign(F,JmenoSouboru);
  Reset(F,1);
  Seek(F,Pozice);
  BlockRead(F,RLEdelka,2);
  RLEDekompress;
  MovArraysTo3;
  Rozkodovat;
  Close(F);
End;


Procedure LoadBmpFile(JmenoSouboru: string; pozice: LongInt; StartColor: Byte);
Var
  I,N: LongInt;
  Pixel1: Byte;
  Pixel2: Byte;
Begin
  Assign(F,JmenoSouboru);
  Reset(F,1);
  Seek(F,pozice);

  {Header}
  BlockRead(F,BMP.Header,54);

  {Palette}
  For I:=0 to 15 do
  Begin
    BlockRead(F,BMP.Palette[I].B,1);
    BlockRead(F,BMP.Palette[I].G,1);
    BlockRead(F,BMP.Palette[I].R,1);
    BlockRead(F,BMP.Palette[I].Reserved,1);
    BMP.Palette[I].B:=BMP.Palette[I].B DIV 4;
    BMP.Palette[I].G:=BMP.Palette[I].G DIV 4;
    BMP.Palette[I].R:=BMP.Palette[I].R DIV 4;
    SetPal(StartColor+I,BMP.Palette[I].R,BMP.Palette[I].G,BMP.Palette[I].B);
  End;

  {Data}
  N:=0;
  For I:=0 to (BMP.Header.ImageSize-1) do
  Begin
    BlockRead(F,BMP.DataByte,1);
    Pixel1:=(BMP.DataByte SHR 4);
    Pixel2:=(BMP.DataByte AND 15);
    mem[Buffer[0]:N]:=StartColor+Pixel1;
    mem[Buffer[0]:N+1]:=StartColor+Pixel2;
    Inc(N,2);
  End;

  Close(F);
End;


Procedure LoadBlok(x1,y1,x2,y2,x3,y3,BufferTo: Word);
Var Xa,Ya,x,y,Offset1,Offset2: Word;
Begin
  Xa:=x1; Ya:=y1;
  For y:=y2 to y3 do
  Begin
    For x:=x2 to x3 do
    Begin
      Offset1:=Ya*320+Xa; Offset2:=y*160+x;
      mem[BufferTo:Offset1]:=mem[Buffer[0]:Offset2];
      inc(Xa);
    End;
    Xa:=x1; Inc(Ya);
  End;
End;


Procedure LoadBlokM(x1,y1,x2,y2,x3,y3,BufferTo: Word);
Var Xa,Ya,x,y,Offset1,Offset2: Word;
Begin
  Xa:=x1; Ya:=y1;
  For y:=y2 to y3 do
  Begin
    For x:=x3 downto x2 do
    Begin
      Offset1:=Ya*320+Xa; Offset2:=y*160+x;
      mem[BufferTo:Offset1]:=mem[Buffer[0]:Offset2];
      inc(Xa);
    End;
    Xa:=x1; Inc(Ya);
  End;
End;


Procedure LoadBitMap(X,Y: Word; BufferTo: Word);
Var xa,ya: Word;
    Offset1: Word;
    Offset2: Word;
Begin
  Offset2:=0;
  For ya:=(BMP.Header.RozsahY-1) downto 0 do
  For xa:=0 to (BMP.Header.RozsahX-1) do
  Begin
    Offset1:=((Y+ya)*320+(X+xa));
    mem[BufferTo:Offset1]:=mem[Buffer[0]:Offset2];
    Inc(Offset2);
  End;
End;


Procedure LoadBitMapM(X,Y: Word; BufferTo: Word);
Var xa,ya: Word;
    Offset1: Word;
    Offset2: Word;
Begin
  Offset2:=0;
  For ya:=(BMP.Header.RozsahY-1) downto 0 do
  For xa:=(BMP.Header.RozsahX-1) downto 0 do
  Begin
    Offset1:=((Y+ya)*320+(X+xa));
    mem[BufferTo:Offset1]:=mem[Buffer[0]:Offset2];
    Inc(Offset2);
  End;
End;


Function ReadPixel(X,Y,Buffer:Word): Byte;
Begin
  ReadPixel:=mem[Buffer:Y*320+X];
End;


Procedure WritePixel(X:Word;Y,Color:Byte;Buffer:Word); Assembler;
Asm
  MOV AX, Buffer
  MOV ES, AX

  XOR AX, AX
  INC AX
  SHL AX, 8
  XOR CX, CX
  INC CX
  SHL CX, 6
  ADD AX, CX

  XOR BX, BX
  MOV BL, Y
  MUL BX
  MOV CX, X
  ADD AX, CX

  MOV DI, AX
  XOR AX, AX
  MOV AL, Color
  STOSB
End;


Procedure Blok(x1,y1,x2,y2,Color,Buffer:Word); external;


Procedure Ramecek(X1,Y1,X2,Y2:Word;Color:Byte;Buffer:Word); Assembler;
Asm
  MOV AX, Buffer
  MOV ES, AX

  XOR AX, AX
  INC AX
  SHL AX, 8
  XOR CX, CX
  INC CX
  SHL CX, 6
  ADD AX, CX
  MOV SI, AX

  MOV BX, y1
  MUL BX
  MOV CX, x1
  ADD AX, CX
  MOV DI, AX

  XOR AX, AX
  MOV AL, Color

  MOV DX, x2
  MOV CX, x1
  SUB DX, CX

  MOV CX, DX
  INC CX
@cyklus1:
  STOSB
  LOOP @cyklus1
  DEC DI
  SUB DI, DX
  ADD DI, SI

  MOV CX, y2
  MOV BX, y1
  SUB CX, BX
  DEC CX
@cyklus2:
  STOSB
  DEC DI
  ADD DI, DX
  STOSB
  DEC DI
  SUB DI, DX
  ADD DI, SI
  LOOP @cyklus2

  MOV CX, DX
  INC CX
@cyklus3:
  STOSB
  LOOP @cyklus3
End;


Procedure WriteBlok(x1,y1,x2,y2,x3,y3,BufferFrom,BufferTo: Word); external;


Procedure WriteSprite(x1,y1,x2,y2,x3,y3,BufferFrom,BufferTo: Word); Assembler;
Asm
  PUSH DS

@testing:
  MOV DX, x3
  MOV CX, x2
  SUB DX, CX {DX=delka}
  INC DX
  TEST DX, 0000000000000001b
  JNE @odd

@even:
  MOV AX, BufferTo
  MOV ES, AX
  MOV AX, BufferFrom
  MOV DS, AX

  XOR AX, AX
  INC AX
  SHL AX, 8
  XOR CX, CX
  INC CX
  SHL CX, 6
  ADD AX, CX {AX=320}
  PUSH AX

  MOV BX, y1
  MUL BX
  MOV CX, x1
  ADD AX, CX
  MOV DI, AX {ES:DI BufferTo}

  POP AX
  MOV BX, y2
  MUL BX
  MOV CX, x2
  ADD AX, CX
  MOV SI, AX {DS:SI BufferFrom}

  MOV BX, y3
  MOV DX, y2
  SUB BX, DX {BX=vyska}
  INC BX

@cyklus2:
  MOV DX, x3
  MOV CX, x2
  SUB DX, CX {DX=delka}
  INC DX
  SHR DX, 1

  MOV CX, DX
@cyklus1:
  PUSH BX
  XOR BX, BX
  LODSW
  CMP AX, BX
  JE @je_nulaW
  JNE @neni_nulaW

@je_nulaW:
  INC DI
  INC DI
  JMP @konec

@neni_nulaW:
  CMP AL, BL
  JE @prvnibajt
  CMP AH, BL
  JE @druhybajt
  JMP @oba2bajty

@prvnibajt:
  INC DI
  CMP AH, BL
  JE @equal1
  JMP @equal2
@equal1:
  INC DI
  JMP @konec
@equal2:
  DEC SI
  MOVSB
  JMP @konec

@druhybajt:
  DEC SI
  DEC SI
  MOVSB
  INC DI
  INC SI
  JMP @konec

@oba2bajty:
  DEC SI
  DEC SI
  MOVSW

@konec:
  POP BX
  LOOP @cyklus1
  MOV CX, BX
  SHL DX, 1
  SUB DI, DX
  ADD DI, 320
  SUB SI, DX
  ADD SI, 320
  SHR DX, 1
  DEC BX
  LOOP @cyklus2
  JMP @final

@odd:
  MOV AX, BufferTo
  MOV ES, AX
  MOV AX, BufferFrom
  MOV DS, AX

  XOR AX, AX
  INC AX
  SHL AX, 8
  XOR CX, CX
  INC CX
  SHL CX, 6
  ADD AX, CX {AX=320}
  PUSH AX

  MOV BX, y1
  MUL BX
  MOV CX, x1
  ADD AX, CX
  MOV DI, AX {ES:DI BufferTo}
  MOV DX, x3
  MOV CX, x2
  SUB DX, CX {DX=delka}
  ADD DI, DX

  POP AX
  MOV BX, y2
  MUL BX
  MOV CX, x2
  ADD AX, CX
  MOV SI, AX {DS:SI BufferFrom}
  MOV DX, x3
  MOV CX, x2
  SUB DX, CX {DX=delka}
  ADD SI, DX

  MOV CX, y3
  MOV DX, y2
  SUB CX, DX {CX=vyska}
  INC CX

  XOR BL, BL
@cyklus3:
  LODSB  {DS:SI -> AL}
  CMP AL, BL
  JE @je_nulaB
  JNE @neni_nulaB

@je_nulaB:
  DEC SI
  ADD SI, 320
  ADD DI, 320
  JMP @konec_nulaB

@neni_nulaB:
  STOSB
  DEC SI
  ADD SI, 320
  DEC DI
  ADD DI, 320

@konec_nulaB:
  LOOP @cyklus3

  JMP @even

@final:
  POP DS
End;


Procedure LoadDefaultFont(x1,y1,Color,BufferTo: Word);
Var
  FontBufP: Pointer;
  FontBufSeg: Word;
  A,I,N: Word;
  X,Y: Word;
Begin
  GetMem(FontBufP,1024);
  FontBufSeg:=Seg(FontBufP^);
  A:=0;
  For I:=0 to 124 do
  Begin
    Dec2Bin(DefaultFont[I]);
    For N:=0 to 7 do
    If b[N]>0 then mem[FontBufSeg:A+(7-N)]:=Color
              else mem[FontBufSeg:A+(7-N)]:=0;
    Inc(A,8);
  End;
  I:=0;
  For Y:=0 to 19 do
  For X:=0 to 49 do
  Begin
    WritePixel(x1+X,y1+Y,mem[FontBufSeg:I],BufferTo);
    Inc(I);
  End;
  FreeMem(FontBufP,1024);
End;


Procedure WriteZnak(FontBuffer,FontX,FontY,FontDelka,FontVyska,x,y:Word;Znak:Char;BufferTo:Word);
Var radek,N,zn: Byte;
Begin
  zn:=Ord(Znak);

  If ((zn>=97) and (zn<124)) then
  Begin
    If (zn>=97) and (zn<107) then {a..j , 1.radek}
    Begin
      N:=zn-97;
      radek:=0;
    End;
    If ((zn>=107) and (zn<117)) then {k..t , 2.radek}
    Begin
      N:=zn-107;
      radek:=1;
    End;
    If ((zn>=117) and (zn<124)) then {u..z , 3.radek}
    Begin
      N:=zn-117;
      radek:=2;
    End;
    WriteSprite(x,y,FontX+N*FontDelka,FontY+radek*FontVyska,
                    FontX+N*FontDelka+(FontDelka-1),FontY+radek*FontVyska+(FontVyska-1),
                    FontBuffer,BufferTo);
  End;

  If ((zn>=48) and (zn<58)) then {0..9 , 4.radek}
  Begin
    N:=zn-48;
    radek:=3;
    WriteSprite(x,y,FontX+N*FontDelka,FontY+radek*FontVyska,
                    FontX+N*FontDelka+(FontDelka-1),FontY+radek*FontVyska+(FontVyska-1),
                    FontBuffer,BufferTo);
  End;

  If zn=61 then {=}
  WriteSprite(x,y,FontX+6*FontDelka,FontY+2*FontVyska,FontX+6*FontDelka+(FontDelka-1),FontY+2*FontVyska+(FontVyska-1),
  FontBuffer,BufferTo);

  If zn=43 then {+}
  WriteSprite(x,y,FontX+7*FontDelka,FontY+2*FontVyska,FontX+7*FontDelka+(FontDelka-1),FontY+2*FontVyska+(FontVyska-1),
  FontBuffer,BufferTo);

  If zn=45 then {-}
  WriteSprite(x,y,FontX+8*FontDelka,FontY+2*FontVyska,FontX+8*FontDelka+(FontDelka-1),FontY+2*FontVyska+(FontVyska-1),
  FontBuffer,BufferTo);

  If zn=47 then {/}
  WriteSprite(x,y,FontX+9*FontDelka,FontY+2*FontVyska,FontX+9*FontDelka+(FontDelka-1),FontY+2*FontVyska+(FontVyska-1),
  FontBuffer,BufferTo);
End;


Procedure WriteText(FontBuffer,FontX,FontY,FontDelka,FontVyska,mezera,x,y:Word;retezec:string;BufferTo:Word);
Var I: Word;
    posuv:Byte;
    Ordinal: Byte;
Begin
  posuv:=FontDelka+mezera;
  For I:=1 to Length(retezec) do
  Begin
    Ordinal:=Ord(retezec[I]);
    WriteZnak(FontBuffer,FontX,FontY,FontDelka,FontVyska,X,Y,retezec[I],BufferTo);
    Inc(X,posuv);
  End;
End;


Procedure WriteNumber(FontBuffer,FontX,FontY,FontDelka,FontVyska,mezera,x,y:Word;Cislo:Longint;BufferTo:Word);
Var MZbytek,MRozdil,delitel: Longint;
    Zapisovat:Boolean;
    posuv,pocet:Byte;
Begin
  posuv:=0;
  Zapisovat:=False;
  delitel:=1000000;
  For pocet:=0 to 6 do
  Begin
    If delitel>0 then
    Begin
      MRozdil:=Cislo div delitel;
      MZbytek:=Cislo mod delitel;
    End else
    Begin
      MRozdil:=0;
      MZbytek:=0;
    End;
    If MRozdil>0 then Zapisovat:=True;
    If Zapisovat=True then
    Begin
      WriteSprite(x+posuv,y,FontX+(MRozdil*FontDelka),FontY,FontX+(MRozdil*FontDelka)+FontDelka-1,FontY+FontVyska-1,
      FontBuffer,BufferTo);
      Inc(posuv,FontDelka+mezera);
    End;
    Cislo:=MZbytek;
    If delitel>0 then delitel:=delitel div 10;
  End;
  If (Zapisovat=False) And (MRozdil=0) then
  WriteSprite(x+posuv,y,FontX+(MRozdil*FontDelka),FontY,FontX+(MRozdil*FontDelka)+FontDelka-1,FontY+FontVyska-1,
  FontBuffer,BufferTo);
End;


Procedure FlipPage(BufferFrom,BufferTo: Word); external;


Procedure ClearPage(Buffer:Word); external;


{SECTION MAP XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Procedure InitMapBuffers(Velikost: Word);
Var x: Word;
Begin
  Map.Size:=Velikost;
  GetMem(Map.MapBufferP,Map.Size); Map.MapBuffer:=Seg(Map.MapBufferP^);
  For x:=0 to Map.Size-1 do mem[Map.MapBuffer:x]:=0; {vymaz bufferu}
End;


Procedure ShutdownMapBuffers;
Begin
  FreeMem(Map.MapBufferP,Map.Size);
End;


Function GetHDDMapByte: Byte;
Var ReadByte: Byte;
Begin
  BlockRead(Map.MapFile,ReadByte,1);
  GetHDDMapByte:=ReadByte;
End;


Procedure RLEDekompresMap;
Var
  WritedBA: Byte; {znak A}
  WritedBB: Byte; {je-li komprese tak stejny jako znak A}
  WritedBC: Byte; {pocet kolikrat tam je znak A }
  I,A,posun: Word;
Begin
  I:=0; posun:=0;
  While not (posun=Map.DelkaRLE) do
  Begin

    WritedBA:=GetHDDMapByte;                 {nacteme A}
    Inc(posun);
    If posun=Map.DelkaRLE then               {je-li konec zapsat a BREAK}
    Begin
      mem[Map.MapBuffer:I]:=WritedBA;
      Break;
    End;

    WritedBB:=GetHDDMapByte;            {nacteme B}
    Inc(posun);
    If posun=Map.DelkaRLE then          {je-li konec zapsat a BREAK}
    Begin
      mem[Map.MapBuffer:I]:=WritedBA;
      mem[Map.MapBuffer:I+1]:=WritedBB;
      Break;
    End;

    If WritedBA=WritedBB then  {jsou-li dva stejne tzn. nasleduje pocet}
    Begin
      WritedBC:=GetHDDMapByte; {muzeme nacist pocet}
      Inc(posun);
      For A:=1 to WritedBC do
      Begin
        mem[Map.MapBuffer:I]:=WritedBA; {zapisujeme WritedBC krat}
        Inc(I);
      End;
    End else {jsou dva ruzne}
    Begin
      mem[Map.MapBuffer:I]:=WritedBA;   {zapisme jeden a navrat nahoru}
      Inc(I);
      Dec(posun);                       {posuneme index o jednu nazpet}
      Seek(Map.MapFile,FilePos(Map.MapFile)-1);
    End;

  End; {While End}
End;


Procedure LoadMapFile(soubor: string; pozice: Longint);
Begin
  Assign(Map.MapFile,soubor);
  Reset(Map.MapFile,1);
  Seek(Map.MapFile,pozice);
  BlockRead(Map.MapFile,Map.DelkaRLE,2);
  RLEDekompresMap;
  Close(Map.MapFile);
End;


Procedure SetMapByte(MapOffset:Word; bajt:Byte); Assembler;
Asm
  MOV AX, Map.MapBuffer
  MOV ES, AX

  MOV DI, MapOffset
  XOR AX, AX
  MOV AL, bajt
  STOSB
End;


Function GetMapByte(MapOffset: Word): Byte; Assembler;
Asm
  PUSH DS
  MOV SI, Map.MapBuffer
  MOV DS, SI

  MOV SI, MapOffset
  LODSB                         {AL:=DS:SI}
  POP DS
End;


{SECTION KEYBOARD XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{$F+}
Procedure KeyboardHandler(Flags, CS, IP, AX, BX, CX, DX,SI, DI, DS, ES, BP: Word); Interrupt;
Begin
  PresseDKey:=Port[$60];
  If PresseDKey<128 then Key[PresseDKey]:=True;
  If PresseDKey>128 then Key[PresseDKey-128]:=False;
  Port[$20]:=$20;
End;
{$F-}


Procedure InitKeyboard;
Begin
  GetIntVec(9, @BIOSKeyboardHandler);
  SetIntVec(9, Addr(KeyboardHandler));
End;


Procedure ShutdownKeyboard;
Begin
  SetIntVec(9, @BIOSKeyboardHandler);
End;


{SECTION XMS XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Function DetekujXms: Word;
{ Vrati 0, pokud je ovladac XMS nainstalovany.}
{ zmeni global. prom. xmsAdr, xmsVersion, ovlXmsVersion a hmaDetect}
Var vrat:word;
Begin
  asm
    mov vrat,1    { predpokladame chybu }
    mov ax,4300h  { sluzba 4300h - XMS, zjisti pritomnost XMS}
    int 2Fh       { multiplexni preruseni (preruseni nainstalovanych ovladacu)}
    cmp al,80h    { (pokud mame v al 80h je XMS) }
    jnz @konec    { ...XMS neni, tak skocime na konec... }
    mov vrat,0    { XMS je!!! }
    mov ax,4310h  { sluzba 4310h, vrat adresu obsluzneho programu }
    int 2Fh
    mov word ptr [xmsadr],bx    { do xmsAdr si dame adresu kde mame ovladac }
    mov word ptr [xmsadr+2],es

    mov ah,00h             {vrat stav XMS}
    call [xmsadr]
    mov [xmsVersion],ax    { verze xms v BCD }
    mov [ovlXmsVersion],bx { verze ovladace. Opet v BCD }
    mov [hmaDetect],dx     { true/false }

   @konec:
  End;
  DetekujXms:=vrat;
  If vrat=0 then XMSError:=True;
End;


Procedure GetSizeXms(var celkemXMS,blokXMS: Word);
{ V celkem vraci celkovou (volnou?) velikost Xms a v blok kolik si maximalne muzeme alokovat pro 1 blok. }
{ Vetsinou jsou obe velikosti shodne. }
Var celkem,blok:word;
Begin
  asm
    mov  ah,08h  {zjisti velikost XMS}
    call [xmsadr]
    mov  [xmsChyba],bl    { chyba? }
    mov  [celkem],dx
    mov  [blok],dx
  end;
  celkemXMS:=celkem;
  blokXMS:=blok;
End;


Function AlokujXms(kolik: Word): Word;
{ Kolik je v Kb. Vraci handle (rukojet) alokovaneho bloku. }
Var vrat:word;
Begin
  Asm
    mov  ah,09h          {alokuj XMS}
    mov  dx,[kolik]
    call [xmsadr]
    mov  [vrat],dx
    mov  [xmsChyba],bl   { chyba? }
  End;
  AlokujXms:=vrat;
End;


Procedure UvolniXms(handle: Word);
{ Vsechny bloky, ktere jsme si alokovali bychom meli uvolnit. }
{ Jinak budou az do restartu systemu nepouzitelne pro jine aplikace. }
Begin
  Asm
    mov  ah,0ah
    mov  dx,[handle]
    call [xmsadr]
    mov  [xmsChyba],bl    { chyba? }
  End;
End;


Procedure MoveToXMS(Handle: Word; XMSOffset: LongInt; Var Source; BlockLength: LongInt);
Var
  ParamBlock: XMSParamBlock;
  XSeg,PSeg,POfs: Word;
Begin
  If Handle<>0 then
  Begin
    XMSchyba:=0;
    With ParamBlock Do
      Begin
        Length:=BlockLength;
        SHandle:=0;
        SOffset[1]:=Ofs(Source);
        SOffset[2]:=Seg(Source);
        DHandle:=Handle;
        DOffset[1]:=Word(XMSOffset AND $FFFF);
        DOffset[2]:=Word(XMSOffset SHR 16);
      End;
    PSeg:=Seg(ParamBlock);
    POfs:=Ofs(ParamBlock);
    XSeg:=Seg(XMSAdr);
    Asm
      Push DS
      Mov  AH,0Bh
      Mov  SI,POfs
      Mov  BX,XSeg
      Mov  ES,BX
      Mov  BX,PSeg
      Mov  DS,BX
      Call [ES:XMSAdr]
      Or   AX,AX
      Jne  @@1
      Mov  XMSChyba,BL
  @@1:
      Pop  DS
    End;
  End;
End;


Procedure MoveFromXMS(Handle: Word; XMSOffset: LongInt; Var Dest; BlockLength: LongInt);
Var
  ParamBlock: XMSParamBlock;
  XSeg,PSeg,POfs: Word;
Begin
  If Handle<>0 then
  Begin
    XMSChyba:=0;
    With ParamBlock Do
      Begin
        Length:=BlockLength;
        SHandle:=Handle;
        SOffset[1]:=Word(XMSOffset AND $FFFF);
        SOffset[2]:=Word(XMSOffset SHR 16);
        DHandle:=0;
        DOffset[1]:=Ofs(Dest);
        DOffset[2]:=Seg(Dest);
      End;
    PSeg:=Seg(ParamBlock);
    POfs:=Ofs(ParamBlock);
    XSeg:=Seg(XMSAdr);
    Asm
      Push DS
      Mov  AH,0Bh
      Mov  SI,POfs
      Mov  BX,XSeg;
      Mov  ES,BX
      Mov  BX,PSeg
      Mov  DS,BX
      Call [ES:XMSAdr]
      Or   AX,AX
      Jne  @@1
      Mov  XMSChyba,BL
  @@1:
      Pop  DS
    End;
  End;
End;


{SECTION SOUND BLASTER XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
function CtiBLASTER : boolean;
var PromBlast : string;
begin
 CtiBlaster := False;
 PromBlast := GetEnv('BLASTER');
 if PromBlast = '' then Exit;
 if Pos('A',PromBlast) = 0 then Exit else
  Adr := (Ord(PromBlast[Pos('A',PromBlast)+1])-Ord('0'))*256+
         (Ord(PromBlast[Pos('A',PromBlast)+2])-Ord('0'))*16+
         (Ord(PromBlast[Pos('A',PromBlast)+3])-Ord('0'));
 if Pos('I',PromBlast) = 0 then Exit else
  IRQ := Ord(PromBlast[Pos('I',PromBlast)+1])-Ord('0');
 if Pos('D',PromBlast) = 0 then Exit else
  DMA8 := Ord(PromBlast[Pos('D',PromBlast)+1])-Ord('0');
 if Pos('H',PromBlast) = 0 then DMA16 := 255 else
  DMA16 := Ord(PromBlast[Pos('H',PromBlast)+1])-Ord('0');
 if Pos('T',PromBlast) = 0 then Exit else
  Typ := Ord(PromBlast[Pos('T',PromBlast)+1])-Ord('0');
 if not (DMA8 in [0,1,3]) then Exit;
 if DMA16 <> 255 then
  if not (DMA16 in [5,6,7]) then Exit;
 if not (IRQ in [2,3,5,7,10,11,12,15]) then Exit;
 CtiBlaster := True;
end;


function VytvorBuffer : boolean;
var PracBuf : pointer;
    Stranka1,Stranka2,I : word;
begin
 VytvorBuffer := False;
 if MaxAvail >= 65536 then
 begin
  GetMem(PracBuf,32768);
  LinearAdr := longint(Seg(PracBuf^)) shl 4 + Ofs(PracBuf^);
  Stranka1 := LinearAdr shr 16;
  Stranka2 := (LinearAdr+32767) shr 16;
  if Stranka1 <> Stranka2 then
  begin
   GetMem(SBbuffer,32768);
   SBBufferSeg:=Seg(SBbuffer^);
   FreeMem(PracBuf,32768);
  end else
  begin
   SBBuffer := PracBuf;
   SBBufferSeg:=Seg(SBbuffer^);
  end;
  For I:=0 to 32767 do mem[SBBufferSeg:I]:=$80;
  LinearAdr := longint(Seg(SBBuffer^)) shl 4 + Ofs(SBBuffer^);
  Stranka := LinearAdr shr 16;
  OfsStranky := LinearAdr and $ffff;
  VytvorBuffer := True;
 end;
end;


Function GetSBOffset2: Word;
Var Ukazatel: Word;
Begin
  Ukazatel := Port[DMAOfs[DMA8]];
  Ukazatel := Ukazatel + Port[DMAOfs[DMA8]] shl 8;
  GetSBOffset2 := Ukazatel;
End;


Function GetSBOffset: Word;
Var Ukazatel: Word;
Begin
  Ukazatel := Port[DMAOfs[DMA8]];
  Ukazatel := Ukazatel + Port[DMAOfs[DMA8]] shl 8;
  GetSBOffset := Ukazatel - SBOffsetMIN;
End;


procedure SBObsluha; interrupt;
var Prac: byte;
    A,I: Word;
begin
 Prac := Port[Adr+$e];
 Port[$20] := $20;
 If IRQ in [2]+[8..15] then Port[$a0] := $20;

 If HrajeLongRaw=True then
 Begin
   If DelkaZbytku<=8192 then
   Begin
     If Odd(DelkaZbytku)
     then MoveFromXMS(Sample[CisloRawu].Handle,AktPos,mem[Buffer[0]:0],DelkaZbytku-1)
     else MoveFromXMS(Sample[CisloRawu].Handle,AktPos,mem[Buffer[0]:0],DelkaZbytku);
     For I:=0 to 8191 do mem[SBBufferSeg:I+AktCast*8192]:=mem[Buffer[0]:I];
     DelkaZbytku:=0;
     AktPos:=0;
     HrajeLongRaw:=False;
   End;
   If DelkaZbytku>8192 then
   Begin
     MoveFromXMS(Sample[CisloRawu].Handle,AktPos,mem[Buffer[0]:0],8192);
     For I:=0 to 8191 do mem[SBBufferSeg:I+AktCast*8192]:=mem[Buffer[0]:I];
     If DelkaZbytku>8192 then Dec(DelkaZbytku,8192);
     Inc(AktPos,8192);
   End;
 End else
 Begin
   A:=0;
   For I:=0 to 2047 do
   Begin
     memL[SBBufferSeg:A+AktCast*8192]:=$80808080;
     Inc(A,4);
   End;
 End;

 AktCast := (AktCast+1) and 3;
 If AktCast=0 then SBOffsetMIN:=GetSBOffset2;
 If AktCast=3 then SBOffsetMAX:=GetSBOffset2;
end;


procedure DSPwrite(Data : byte); assembler;
asm
   mov	dx,adr
   add	dx,$c
@cekame:
   in	al,dx
   and	al,$80
   jnz	@cekame
   mov	al,data
   out	dx,al
end;


procedure OdmaskujINT;
begin
 case IRQ of
   2 : Port[$a1] := Port[$a1] and not 2;
  10 : Port[$a1] := Port[$a1] and not 4;
  11 : Port[$a1] := Port[$a1] and not 8;
  else Port[$21] := Port[$21] and not (1 shl IRQ);
 end;
 if IRQ in [2, 10, 11] then Port[$21] := Port[$21] and not 4;
end;


procedure PovolDMA;
begin
 Port[DMA8reg[0]] := 4 or DMA8;
 Port[DMA8reg[2]] := 0;
 Port[DMA8reg[1]] := $58 or DMA8;
 Port[DMAstr[DMA8]] := byte(Stranka);
 Port[DMAofs[DMA8]] := Lo(OfsStranky);
 Port[DMAofs[DMA8]] := Hi(OfsStranky);
 Port[DMAvel[DMA8]] := $ff;	{lo}
 Port[DMAvel[DMA8]] := $7f;	{hi}
 Port[DMA8reg[0]] := DMA8;
end;


procedure StartSB; assembler;
asm
  push	$d1
  call	DSPwrite
  push	$40
  call	DSPwrite
  push	131             {nastavime frekvenci pres konstantu}
  call	DSPwrite
  call	povolDMA
  push	$48
  call	DSPwrite
  push	$ff
  call	DSPwrite
  push	$1f
  call	DSPwrite
  push	$1c
  call	DSPwrite
end;


procedure ZamaskujINT;
begin
 case IRQ of
   2 : Port[$a1] := Port[$a1] or 2;
  10 : Port[$a1] := Port[$a1] or 4;
  11 : Port[$a1] := Port[$a1] or 8;
  else Port[$21] := Port[$21] or (1 shl IRQ);
 end;
 if IRQ in [2,10,11] then Port[$21] := Port[$21] or 4;
end;


Procedure odinstINT;
Begin
  SetIntVec(INTvec[IRQ],StaraSBObsluha);
End;


procedure ExitSB; assembler;
asm
   push	$d9
   call	DSPwrite
   push	$d0
   call	DSPwrite
   call	odinstINT
   call	ZamaskujINT
   push	$d3
   call	DSPwrite
end;


Procedure SBPlayRaw(Cislo:Byte);
Var I,A: Word;
Begin
  HrajeLongRaw:=False;
  CisloRawu:=Cislo;
  DelkaZbytku:=0;
  AktPos:=0;

  A:=0;
  For I:=0 to 8191 do
  Begin
    memL[SBBufferSeg:A]:=$80808080;
    Inc(A,4);
  End;

  A:=0;
  For I:=0 to 8191 do
  Begin
    memL[Buffer[0]:A]:=$80808080;
    Inc(A,4);
  End;

  If Sample[Cislo].Delka>32768 then
  Begin
    DelkaZbytku:=Sample[Cislo].Delka-32768;
    MoveFromXMS(Sample[Cislo].Handle,0,mem[Buffer[0]:0],32768);
    A:=GetSBOffset+200;
    A:=A and $7fff;
    For I:=0 to 32767 do
    Begin
      mem[SBBufferSeg:A]:=mem[Buffer[0]:I];
      Inc(A);
      A:=A and $7fff;
    End;
    AktPos:=32768;
    HrajeLongRaw:=True;
  End else
  Begin
    If Odd(Sample[Cislo].Delka)
    then MoveFromXMS(Sample[Cislo].Handle,0,mem[Buffer[0]:0],Sample[Cislo].Delka-1)
    else MoveFromXMS(Sample[Cislo].Handle,0,mem[Buffer[0]:0],Sample[Cislo].Delka);
    A:=GetSBOffset+200;
    A:=A and $7fff;
    For I:=0 to Sample[Cislo].Delka do
    Begin
      mem[SBBufferSeg:A]:=mem[Buffer[0]:I];
      Inc(A);
      A:=A and $7fff;
    End;
  End;
End;


Procedure InitSB;
Begin
  CtiBlaster;
  VytvorBuffer;
  GetIntVec(INTvec[IRQ],StaraSBObsluha);
  SetIntVec(INTvec[IRQ],@SBObsluha);
  OdmaskujINT;
  AktCast:=0;
  HrajeLongRaw:=False;
  StartSB;
End;


Procedure ShutdownSB;
Begin
  ExitSB;
  FreeMem(SBBuffer,32768);
End;


{SECTION TIMER XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Procedure Wait(ms: Word);
Begin
  If ms>0 then
  Begin
    delaycounter:=0;
    waiting:=True;
    While delaycounter<ms*8 do Begin End;
    waiting:=False;
    delaycounter:=0;
  End;
End;


Procedure Sound(Hertz: Word); Assembler;
Asm
  MOV    BX,SP
  MOV    BX,&Hertz
  MOV    AX,34DDh
  MOV    DX,0012h
  CMP    DX,BX
  JNB    @J1
  DIV    BX
  MOV    BX,AX
  IN     AL,61h
  TEST   AL,03h
  JNZ    @J2
  OR     AL,03h
  OUT    61h,AL
  MOV    AL,-4Ah
  OUT    43h,AL
@J2:
  MOV    AL,BL
  OUT    42h,AL
  MOV    AL,BH
  OUT    42h,AL
@J1:
End;


Procedure Silence; Assembler;
Asm
  IN     AL,61h
  AND    AL,0FCh
  OUT    61h,AL
End;


Procedure Stopky_Start;
Begin
  StopkyTics:=0;
  StopkyActive:=True;
End;


Procedure Stopky_Stop;
Begin
  StopkyActive:=False;
End;


Function FPS2s: Boolean;
Begin
  If fps_helper<100 then FPS2s:=False {false v prvni vterine}
                    else FPS2s:=True; {true ve druhe vterine}
End;


Function Stopky_GetNumber: LongInt;
Begin
  Stopky_GetNumber:=StopkyTics;
End;


Procedure Delay; {MIDI Delay 10ms}
Begin
  Wait(10);
End;


function TestGM(Adr : word) : boolean; assembler;
asm
  mov	bl,0
  call	delay  {spozdeni 10 ms}
  mov	dx,adr
  inc	dx
  in	al,dx
  and	al,$40
  or	al,al
  jnz	@neni  {je Port[Adr+1] and $40 = 0?}
  dec	dx
  mov	al,$f8  {provedeme reset}
  out	dx,al
  call	delay
  inc	dx
  in	al,dx
  and	al,$40
  or	al,al
  jnz	@neni  {je na dane adrese GM cip?}
  inc	bl
@neni:
  mov	al,bl
end;


Procedure SetupGMAdr;
Var TestAdr,I: Word;
Begin
  GMAdr:=0;
  For I:=0 to 11 do
  Begin
    Case I of
      0: TestAdr:=$220;
      1: TestAdr:=$230;
      2: TestAdr:=$240;
      3: TestAdr:=$250;
      4: TestAdr:=$300;
      5: TestAdr:=$320;
      6: TestAdr:=$330;
      7: TestAdr:=$332;
      8: TestAdr:=$334;
      9: TestAdr:=$336;
     10: TestAdr:=$340;
     11: TestAdr:=$360;
    End;
    If TestGM(TestAdr)=True then GMAdr:=TestAdr+1;
  End;
End;


procedure WriteGM; assembler;
asm
  mov	dx,gmadr
  push	ax
  xor	ax,ax
@cekej:
  dec	ah
  jz	@vyprsel
  in	al,dx
  and	al,$40	{je mozne vysilat?}
  jnz	@cekej
@vyprsel:
  dec	dx
  pop	ax
  out	dx,al
end;


function ReadGM : byte; assembler;
asm
  mov	dx,gmadr
  xor	ax,ax
@cekej:
  dec	ah
  jz	@vyprsel
  in	al,dx
  and	al,$80	{je mozne cist?}
  jnz	@cekej
@vyprsel:
  dec	dx
  in	al,dx
end;


procedure ResetGM; assembler;
asm
  mov	dx,gmadr
  mov	al,$ff	{xor	ax,ax; dec	ax}
  out	dx,al
  call	readgm
  xor	ax,ax
@cekej:
  dec	ah
  jz	@vyprsel
  in	al,dx
  and	al,$40
  jnz	@cekej
@vyprsel:
  mov	al,$3f
  out	dx,al  {tady je vyjimka; neni tu DEC DX}
end;


procedure SetNastroj(Kanal,Cislo : byte); assembler;
asm
  mov	al,kanal
  add	al,$c0
  call	writegm
  mov	al,cislo
  call	writegm
end;


procedure SetBalance(Kanal,Poloha : byte); assembler;
asm
  mov	al,kanal
  add	al,$b0
  call	writegm
  mov	al,10
  call	writegm
  mov	al,poloha
  call	writegm
end;


procedure NotaOn(Kanal,Nota,Hlasitost : byte); assembler;
asm
  mov	al,kanal
  add	al,$90
  call	writegm
  mov	al,nota
  call	writegm
  mov	al,hlasitost
  call	writegm
end;


procedure NotaOff(Kanal,Nota,Hlasitost : byte); assembler;
asm
  mov	al,kanal
  add	al,$80
  call	writegm
  mov	al,nota
  call	writegm
  mov	al,hlasitost
  call	writegm
end;


Procedure InitGM;
Var x: Word;
Begin
  GetMem(Melody.DataPoint,9008); Melody.DataSeg:=Seg(Melody.DataPoint^);
  For x:=0 to 9000 do mem[Melody.DataSeg:x]:=0;
  GMHraje:=False;
  SetupGMAdr;
  ResetGM;
End;


Procedure ShutdownGM;
Begin
  ResetGM;
  FreeMem(Melody.DataPoint,9008);
End;


Procedure SetMelodyTempo(Temp: Byte);
Begin
  If ((Temp>0) and (Temp<51))
  then Begin
         Inc(Temp,150);
         Melody.Delay:=(2000-((Temp-1)*10))*8;
       End
  else Melody.Delay:=210*8;
End;


Procedure SetKanalVolume(Kan,Vol: Byte);
Begin
  If Vol<128 then Melody.Kanal[Kan].Volume:=Vol;
End;


Procedure SetupGM;
Var I: Byte;
Begin
  SetNastroj(9,35);
  SetBalance(9,Melody.Kanal[0].Balance);
  For I:=1 to 3 do
  Begin
    SetNastroj(I,Melody.Kanal[I].Nastroj);
    SetBalance(I,Melody.Kanal[I].Balance);
  End;
  SetMelodyTempo(Melody.Tempo);
  SetKanalVolume(9,127);
  SetKanalVolume(1,127);
  SetKanalVolume(2,127);
  SetKanalVolume(3,127);
End;


Procedure CountMelodyLenght;
Var I: Word;
    kan: Byte;
    bajt: Byte;
    del1: array[0..3] of Word;
    del2: array[0..3] of LongInt;
    delka: LongInt;
Begin
  For I:=0 to 3 do
  Begin
    del1[I]:=0;
    del2[I]:=0;
  End;

  For kan:=0 to 3 do
  Begin
    For I:=2249 downto 0 do
    Begin
      bajt:=mem[Melody.DataSeg:kan*2250+I];
      If bajt<>120 then
      Begin
        del1[kan]:=I;
        Break;
      End;
    End;
  End;

  For kan:=0 to 3 do
  Begin
    For I:=0 to del1[kan] do
    Begin
      bajt:=mem[Melody.DataSeg:kan*2250+I];
      If bajt<128 then Inc(del2[kan])
                  else Begin
                         Dec(bajt,128);
                         Inc(del2[kan],bajt);
                       End;
    End;
  End;

  delka:=del2[0];
  If del2[1]>delka then delka:=del2[1];
  If del2[2]>delka then delka:=del2[2];
  If del2[3]>delka then delka:=del2[3];
  Melody.Delka:=delka;
End;


Procedure CountMelodySegmentLenght(Start,Finish: Word);
Var I: Word;
    kan: Byte;
    bajt: Byte;
    del1: array[0..3] of Word;
    del2: array[0..3] of LongInt;
    delka: LongInt;
Begin
  For I:=0 to 3 do
  Begin
    del1[I]:=0;
    del2[I]:=0;
  End;

  For kan:=0 to 3 do
  Begin
    For I:=Finish downto Start do
    Begin
      bajt:=mem[Melody.DataSeg:kan*2250+I];
      If bajt<>120 then
      Begin
        del1[kan]:=I;
        Break;
      End;
    End;
  End;

  For kan:=0 to 3 do
  Begin
    For I:=0 to del1[kan] do
    Begin
      bajt:=mem[Melody.DataSeg:kan*2250+I];
      If bajt<128 then Inc(del2[kan])
                  else Begin
                         Dec(bajt,128);
                         Inc(del2[kan],bajt);
                       End;
    End;
  End;

  delka:=del2[0];
  If del2[1]>delka then delka:=del2[1];
  If del2[2]>delka then delka:=del2[2];
  If del2[3]>delka then delka:=del2[3];
  Melody.Delka:=delka;
End;


Procedure SetupArray2;
Var I: Word;
Begin
  For I:=0 to 8999 do mem[Melody.DataSeg:I]:=mem[RLESeg:I];
  Melody.Kanal[0].Nastroj:=mem[RLESeg:9000];
  Melody.Kanal[0].Balance:=mem[RLESeg:9001];
  Melody.Kanal[0].DefaultOktava:=mem[RLESeg:9002];
  Melody.Kanal[1].Nastroj:=mem[RLESeg:9003];
  Melody.Kanal[1].Balance:=mem[RLESeg:9004];
  Melody.Kanal[1].DefaultOktava:=mem[RLESeg:9005];
  Melody.Kanal[2].Nastroj:=mem[RLESeg:9006];
  Melody.Kanal[2].Balance:=mem[RLESeg:9007];
  Melody.Kanal[2].DefaultOktava:=mem[RLESeg:9008];
  Melody.Kanal[3].Nastroj:=mem[RLESeg:9009];
  Melody.Kanal[3].Balance:=mem[RLESeg:9010];
  Melody.Kanal[3].DefaultOktava:=mem[RLESeg:9011];
  Melody.Tempo:=mem[RLESeg:9012];
  Melody.Repetice:=memW[RLESeg:9013];
  Melody.Delka:=memL[RLESeg:9015];
End;


Procedure LoadMELFile(Filename:String;Pozice:LongInt);
Var I: Word;
    ReadByte: Byte;
Begin
  Assign(F,Filename);
  Reset(F,1);
  Seek(F,Pozice);
  BlockRead(F,RLEdelka,2);
  RLEDekompress;
  SetupArray2;
  Close(F);
  SetupGM;
End;


Procedure StartGMPlay(Temp,Vol:Byte;Start,Finish:Word;Rep:Boolean);
Var I: Byte;
Begin
  Melody.Start:=Start;
  Melody.Finish:=Finish;
  If Finish>0 then CountMelodySegmentLenght(Start,Finish)
              else CountMelodyLenght;
  SetMelodyTempo(Temp);
  For I:=0 to 3 do
  Begin
    SetKanalVolume(I,Vol);
    Melody.Kanal[I].Pos:=Melody.Start;
    Melody.Kanal[I].NotaHraje:=False;
  End;
  Melody.DelayCounter:=0;
  If Rep=True then Melody.Opakovat:=True
              else Melody.Opakovat:=False;
  GMHraje:=True;
End;


Procedure StopGMPlay;
Var I: Byte;
Begin
  GMHraje:=False;
  For I:=0 to 3 do
  Begin
    NotaOff(I,Melody.Kanal[I].FIFO[2],Melody.Kanal[1].Volume);
    NotaOff(I,Melody.Kanal[I].Nota,Melody.Kanal[1].Volume);
    Melody.Kanal[I].Pos:=Melody.Start;
    Melody.Kanal[I].NotaCounter:=0;
    Melody.Kanal[I].NotaHraje:=False;
  End;
End;


Procedure JumpToMelodyRepeat;
Var I: Byte;
Begin
  For I:=0 to 3 do
  Begin
    Melody.Kanal[I].Pos:=Melody.Repetice+1;
    Melody.Kanal[I].NotaCounter:=0;
    Melody.Kanal[I].NotaHraje:=False;
    NotaOff(I,Melody.Kanal[I].FIFO[2],Melody.Kanal[1].Volume);
    NotaOff(I,Melody.Kanal[I].Nota,Melody.Kanal[1].Volume);
  End;
End;


Procedure Start_LoadSymbol(X,Y:Word;BackColor,FrontColor:Byte);
Var I: Byte;
Begin
  LoadSymbol.X:=X;
  LoadSymbol.Y:=Y;
  LoadSymbol.BackColor:=BackColor;
  LoadSymbol.FrontColor:=FrontColor;
  LoadSymbol.OnScreen:=True;
End;


Procedure Stop_LoadSymbol;
Begin
  LoadSymbol.OnScreen:=False;
End;


{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Procedure TimerHandler; Interrupt;
Var I: Byte;
Begin
  {zpozdovac}
  If waiting=True then Inc(delaycounter); {je prave jedna milisekunda}

  {prehravani rawu}
  If RawHraje then
  Begin
    If mem[Buffer[0]:OffsetSpeakeru]>$80
    then Sound(22000) else Silence;
    
    Inc(Sample[PrehravanyZvuk].Pocitadlo);
    If Sample[PrehravanyZvuk].Pocitadlo=Sample[PrehravanyZvuk].Delka
    then Begin RawHraje:=False; Silence; End;
    If OffsetSpeakeru<32768 then Inc(OffsetSpeakeru) else OffsetSpeakeru:=0;
  End;

  {prehravani zvuku}
  If player=10 then If PrehravatZvuk=True then
  Begin
    If memW[SoundDataSeg:memW[ZvukTabSeg:CisloZvuku*4]*2+PosuvZ*2]>0
    then Sound(memW[SoundDataSeg:memW[ZvukTabSeg:CisloZvuku*4]*2+PosuvZ*2])
    else Sound(10); {Silence;}
    Inc(PosuvZ);
    If PosuvZ>memW[ZvukTabSeg:CisloZvuku*4+2] then {prehrali jsme celou delku zvuku}
    Begin
      PrehravatZvuk:=False;
      PosuvZ:=0;
      Silence;
    End
  End;

  {prehravani General MIDI}
  If GMHraje=True then
  Begin
    If Melody.DelayCounter<Melody.Delay-1
    then Inc(Melody.DelayCounter)
    else Begin
           Melody.DelayCounter:=0;

           {zastavujeme hrajici notu, bici nemusime jen nastroje}
           For I:=1 to 3 do
           Begin
             If ((Melody.Kanal[I].Pos>Melody.Start) and (Melody.Kanal[I].NotaCounter=0) and
                 (Melody.Kanal[I].Nota<=120) and (Melody.Kanal[I].NotaHraje=True)) then
             Begin
               NotaOff(I,Melody.Kanal[I].FIFO[2],Melody.Kanal[I].Volume);
               Melody.Kanal[I].FIFO[2]:=Melody.Kanal[I].FIFO[1];
               Melody.Kanal[I].NotaHraje:=False;
             End;
           End;

           {nacitame bajt z pameti, nastavujeme notu, mezeru nebo repetici}
           For I:=0 to 3 do
           Begin
             If ((Melody.Kanal[I].Pos<Melody.Delka) and (Melody.Kanal[I].NotaCounter=0)) then
             Begin
               Melody.Kanal[I].Nota:=mem[Melody.DataSeg:I*2250+Melody.Kanal[I].Pos];
               If Melody.Kanal[I].Nota>=128 then Melody.Kanal[I].NotaCounter:=Melody.Kanal[I].Nota-128; {m}
               If Melody.Kanal[I].Nota<120 then Melody.Kanal[I].FIFO[1]:=Melody.Kanal[I].Nota; {nota}
               If Melody.Kanal[I].Nota=120 then
               Begin
                 Melody.Kanal[I].NotaCounter:=1;
                 Melody.Kanal[I].NotaHraje:=True; {hraje ticho}
               End;
               {prazdne policko}
               If Melody.Kanal[I].Nota=121 then {repetice}
               Begin
                  For I:=0 to 3 do
                  Begin
                    Melody.Kanal[I].Pos:=Melody.Start;
                    Melody.Kanal[I].NotaCounter:=0;
                    Melody.Kanal[I].NotaHraje:=False;
                    NotaOff(I,Melody.Kanal[I].FIFO[2],Melody.Kanal[I].Volume);
                    NotaOff(I,Melody.Kanal[I].Nota,Melody.Kanal[I].Volume);
                  End;
               End;
             End;
           End;

           {spoustime notu aby hrala}
           If ((Melody.Kanal[0].Nota<120) and
               (Melody.Kanal[0].NotaCounter=0))
               then NotaOn(9,Melody.Kanal[0].Nota,Melody.Kanal[0].Volume);
           For I:=1 to 3 do
           Begin
             If ((Melody.Kanal[I].NotaHraje=False) and
                 (Melody.Kanal[I].Nota<120) and
                 (Melody.Kanal[I].NotaCounter=0)) then
                 Begin
                   NotaOn(I,Melody.Kanal[I].Nota,Melody.Kanal[I].Volume);
                   Melody.Kanal[I].NotaHraje:=True;
                 End;
           End;

           {test konce melodie kterykoliv kanal}
           If ((Melody.Kanal[0].Pos=Melody.Delka-1) or
               (Melody.Kanal[1].Pos=Melody.Delka-1) or
               (Melody.Kanal[2].Pos=Melody.Delka-1) or
               (Melody.Kanal[3].Pos=Melody.Delka-1)) then
           Begin
             If Melody.Opakovat=True
             then Begin
                    For I:=0 to 3 do
                    Begin
                      Melody.Kanal[I].Pos:=Melody.Start;
                      Melody.Kanal[I].NotaCounter:=0;
                      Melody.Kanal[I].NotaHraje:=False;
                    End;
                  End
             else StopGMPlay;
           End;

           {odpocet mezery v melodii}
           For I:=0 to 3 do
           If Melody.Kanal[I].NotaCounter>0 then Dec(Melody.Kanal[I].NotaCounter);

           {posouvame se po melodii}
           For I:=0 to 3 do
           Begin
             If ((Melody.Kanal[I].Pos<Melody.Delka) and (Melody.Kanal[I].NotaCounter=0))
             then Inc(Melody.Kanal[I].Pos);
           End;

         End;
  End;

  {loading symbol}
  If LoadSymbol.OnScreen=True then
  Begin
    If LoadSymbol.TimeCounter<399
    then Inc(LoadSymbol.TimeCounter)
    else Begin
           LoadSymbol.TimeCounter:=0;
           If LoadSymbol.FrameCounter<3
           then Inc(LoadSymbol.FrameCounter)
           else LoadSymbol.FrameCounter:=0;
           Blok(LoadSymbol.X,LoadSymbol.Y,LoadSymbol.X+4,LoadSymbol.Y+4,LoadSymbol.BackColor,Buffer[4]);
           Case LoadSymbol.FrameCounter of
           0: Begin
                WritePixel(LoadSymbol.X,LoadSymbol.Y+2,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+1,LoadSymbol.Y+2,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+2,LoadSymbol.Y+2,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+3,LoadSymbol.Y+2,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+4,LoadSymbol.Y+2,LoadSymbol.FrontColor,Buffer[4]);
              End;
           1: Begin
                WritePixel(LoadSymbol.X,LoadSymbol.Y,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+1,LoadSymbol.Y+1,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+2,LoadSymbol.Y+2,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+3,LoadSymbol.Y+3,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+4,LoadSymbol.Y+4,LoadSymbol.FrontColor,Buffer[4]);
              End;
           2: Begin
                WritePixel(LoadSymbol.X+2,LoadSymbol.Y,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+2,LoadSymbol.Y+1,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+2,LoadSymbol.Y+2,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+2,LoadSymbol.Y+3,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+2,LoadSymbol.Y+4,LoadSymbol.FrontColor,Buffer[4]);
              End;
           3: Begin
                WritePixel(LoadSymbol.X,LoadSymbol.Y+4,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+1,LoadSymbol.Y+3,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+2,LoadSymbol.Y+2,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+3,LoadSymbol.Y+1,LoadSymbol.FrontColor,Buffer[4]);
                WritePixel(LoadSymbol.X+4,LoadSymbol.Y,LoadSymbol.FrontColor,Buffer[4]);
              End;
           End; {Case End}
         End;
  End;

  {helper pro vypocet fps kazde 2 sekundy}
  If player=80 then {je setina vteriny ?}
  Begin
    If fps_helper<200 then Inc(fps_helper) else fps_helper:=1;
  End;

  {stopky}
  If StopkyActive=True then Inc(StopkyTics);

  {Player=80 = je prave jedna setina vteriny}
  If player<80 then Inc(player)
               else player:=1;

  {volat BIOS obsluhu preruseni ?}
  clock_ticks:=clock_ticks+counter;
  If clock_ticks>=$10000 then
  Begin
    clock_ticks:=clock_ticks-$10000;
    asm pushf end;
    BIOSTimerHandler;
  End
  else Port[$20]:=$20; {konec preruseni}
End;


Procedure InitTimer;
Var I: Word;
Begin
  fps_helper:=0;
  clock_ticks:=0;
  counter:=$1234DD div 8000;
  GetIntVec(8,@BIOSTimerHandler);
  SetIntVec(8,Addr(TimerHandler));
  Port[$43]:=$34;
  Port[$40]:=counter mod 256;
  Port[$40]:=counter div 256;
  PrehravatZvuk:=False;
  PocetRawu:=0;

  GetMem(SoundDataP,4000); SoundDataSeg:=Seg(SoundDataP^);
  GetMem(ZvukTabP,208); ZvukTabSeg:=Seg(ZvukTabP^);

  For I:=0 to 3999 do mem[SoundDataSeg:I]:=0;
  For I:=0 to 207 do mem[ZvukTabSeg:I]:=0;
End;


Procedure ShutdownTimer;
Begin
  Port[$43]:=$34;
  Port[$40]:=0;
  Port[$40]:=0;
  SetIntVec(8, @BIOSTimerHandler);
  PrehravatZvuk:=False;
  FreeMem(SoundDataP,4000);
  FreeMem(ZvukTabP,208);
End;


Procedure InitRawBuffers;
Var I: Word;
Begin
  If DetekujXMS=0 then GetSizeXMS(XMSCelkemPotreba,XMSBlokPotreba)
                  else XMSError:=True;
End;


Procedure ShutdownRawBuffers;
Var I: Byte;
Begin
  If PocetRawu>0 then
  For I:=0 to PocetRawu-1 do
  UvolniXMS(Sample[I].Handle);
End;


Procedure MovArrayTo2; {RLE => SoundData a ZvukTab}
Var I,A: Word;
Begin
  A:=0;
  For I:=0 to 1999 do
  Begin
    memW[SoundDataSeg:I*2]:=mem[RLESeg:A];
    memW[SoundDataSeg:I*2]:=(memW[SoundDataSeg:I*2] SHL 8) OR mem[RLESeg:A+1];
    Inc(A,2);
  End;
  For I:=0 to 99 do
  Begin
    memW[ZvukTabSeg:I*2]:=mem[RLESeg:A];
    memW[ZvukTabSeg:I*2]:=(memW[ZvukTabSeg:I*2] SHL 8) OR mem[RLESeg:A+1];
    Inc(A,2);
  End;
End;


Procedure LoadSNDFile(Filename:String;Pozice:LongInt);
Var I: Word;
    ReadByte: Byte;
Begin
  Assign(F,Filename);
  Reset(F,1);
  Seek(F,Pozice);
  BlockRead(F,RLEdelka,2);
  RLEDekompress;
  MovArrayTo2;
  Close(F);
End;


Procedure LoadRAWFile(filename:String;Pozice:LongInt;N:Byte); {do 32KB}
Var F: File;
    ReadByte: Byte;
    ReadWord: Word;
    Velikost: Word;
    Casti,I: LongInt;
Begin
  Assign(F,filename);
  Reset(F,1);
  Seek(F,Pozice);
  BlockRead(F,Sample[N].Delka,4);
  Velikost:=(Sample[N].Delka div 1000)+1;
  Sample[N].Handle:=AlokujXMS(Velikost);
  If Sample[N].Delka<32768 then
  Begin
    For I:=0 to Sample[N].Delka-1 do
    Begin
      BlockRead(F,ReadByte,1);
      mem[Buffer[0]:I]:=ReadByte;
    End;
    If Odd(Sample[N].Delka)
    then MoveToXMS(Sample[N].Handle,0,mem[Buffer[0]:0],Sample[N].Delka-1)
    else MoveToXMS(Sample[N].Handle,0,mem[Buffer[0]:0],Sample[N].Delka);
  End else
  Begin
    Casti:=Sample[N].Delka SHR 1;
    For I:=0 to Casti-1 do
    Begin
      BlockRead(F,ReadWord,2);
      memW[Buffer[0]:0]:=ReadWord;
      MoveToXMS(Sample[N].Handle,I*2,mem[Buffer[0]:0],2);
    End;
  End;
  Close(F);
  Inc(PocetRawu);
End;


Procedure PlaySound(Sample:Byte);
Begin
  PrehravatZvuk:=True;
  CisloZvuku:=Sample;
  PosuvZ:=0;
  Silence;
End;


Procedure PlayRaw(Cislo:Byte);
Var I: Word;
Begin
  Inline($FA); {CLI}
  For I:=0 to 32767 do mem[Buffer[0]:I]:=0;
  If Odd(Sample[Cislo].Delka)
  then MoveFromXMS(Sample[Cislo].Handle,0,mem[Buffer[0]:0],Sample[Cislo].Delka-1)
  else MoveFromXMS(Sample[Cislo].Handle,0,mem[Buffer[0]:0],Sample[Cislo].Delka);
  Sample[Cislo].Pocitadlo:=0;
  PrehravanyZvuk:=Cislo;
  OffsetSpeakeru:=0;
  RawHraje:=True;
  Inline($FB); {STI}
End;


Procedure StopPlay;
Begin
  RawHraje:=False;
  PrehravatZvuk:=False;
  Silence;
End;


{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Begin End.

{klavesy xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}
{2}  1  {16} Q  {30} A  {45} X  {1}  Esc        {59} F1   {72} KeyPadUp
{3}  2  {17} W  {31} S  {46} C  {15} TAB        {60} F2   {80} KeyPadDown
{4}  3  {18} E  {32} D  {47} V  {28} Enter      {61} F3   {75} KeyPadleft
{5}  4  {19} R  {33} F  {48} B  {14} BackSpace  {62} F4   {77} KeyPadRight
{6}  5  {20} T  {34} G  {49} N  {57} Space      {63} F5
{7}  6  {21} Y  {35} H  {50} M                  {64} F6   {71} KeyPadHome
{8}  7  {22} U  {36} J          {12} Minus      {65} F7   {79} KeyPadEnd
{9}  8  {23} I  {37} K          {13} Plus       {66} F8   {73} KeyPadPgUp
{10} 9  {24} O  {38} L          {53} Lomitko    {67} F9   {81} KeyPadPgDn
{11} 0  {25} P  {44} Z          {55} Hvezdicka  {68} F10  {82} KeyPadIns
                                                {87} F11  {83} KeyPadDel
{26} HranataZavorka1    {58} CapsLock           {88} F12
{27} HranataZavorka2    {69} NumLock
{41} Semicolon          {70} ScrollLock      {29} LeftControl
{39} Strednik           {76} KeyPad5         {56} LeftAlt
{40} Uvozovka           {78} KeyPadPlus      {42} LeftShift
{51} Carka              {74} KeyPadMinus     {54} RightShift
{52} Tecka
{xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}