Unit Mouse;
{$R-}
{$S-}
{$Q-}

Interface

Function  InitMouse : Integer;
Procedure ShowMouse;
Procedure HideMouse;
Procedure ReadMouse(Var x, y, b : Integer);
Procedure SetRange(x1, y1, x2, y2 : Longint);
Procedure SetMouseLocation(x, y : Longint);
Procedure ReadMickey(Var x, y : Integer);
Function  LeftButtonPressed   : Boolean;
Function  RightButtonPressed  : Boolean;
Function  LeftButtonReleased  : Boolean;
Function  RightButtonReleased : Boolean;
Procedure WaitBClear;


Implementation

Procedure SetMouseLocation(x, y : Longint);

Begin
  Asm
    Mov eax,4
    Mov ecx, [x]
    Mov edx, [y]

    Int 33h
  End;
End;

Procedure SetRange(x1, y1, x2, y2 : Longint);

Begin
  { set horizontal range }
  Asm
    Mov eax,7
    Mov ecx, [x1]
    Mov edx, [x2]
    Shl edx, 1
    Int 33h
  End;

  { set vertical range }
  Asm
    Mov eax,8
    Mov ecx, [y1]
    Mov edx, [y2]
    Int 33h
  End;
End;

Function InitMouse : Integer; Assembler;

Asm
  Xor eax,eax
  Int 33h
End;

Procedure ShowMouse; Assembler;

Asm
  Mov eax,1h
  Int 33h
End;

Procedure HideMouse; Assembler;

Asm
  Mov eax,02h
  Int 33h
End;

Procedure ReadMouse(Var x, y, b : Integer);

Var
  i, j, k : Longint;

Begin
  Asm
    Mov eax,03h
    Int 33h
    Mov i,ebx
    Mov j,ecx
    Mov k,edx
  End;
  x := j Div 2;
  y := k;
  b := i;
End;

Procedure ReadMickey(Var x, y : Integer);

Var
  i, j : Longint;

Begin
  Asm
    Mov eax,0bh
    Int 33h
    Mov i,ecx
    Mov j,edx
  End;
  x := i;
  y := j;
End;

Function  LeftButtonPressed : Boolean; Assembler;

Asm
  Mov eax,5
  Mov ebx,0

  Int 33h
  Cmp ebx,0           { if bx > 0, then the button is pressed }
  Je @Skip
   Mov ebx,1
 @Skip:
  And eax,1
  Or  eax,ebx
End;

Function  RightButtonPressed : Boolean; Assembler;

Asm
  Mov eax,5
  Mov ebx,1
  Int 33h
  Cmp ebx,0           { if bx > 0, then the button is pressed }
  Je @Skip
   Mov ebx,1
 @Skip:
  Shr eax,1
  Or  eax,ebx
End;

Function  LeftButtonReleased : Boolean; Assembler;

Asm
  Mov eax,6
  Mov ebx,0
  Int 33h
  Cmp ebx,0
  Je @Skip
  Mov ebx,1
 @Skip:
  Mov eax,ebx
End;


Function  RightButtonReleased : Boolean; Assembler;

Asm
  Mov eax,6
  Mov ebx,1
  Int 33h
  Cmp ebx,0
  Je @Skip
  Mov ebx,1
 @Skip:
  Mov eax,ebx
End;


Procedure WaitBClear;

Var
  a, b, c : Integer;

Begin
  Repeat
    ReadMouse(a, b, c);
  Until c = 0;
End;

End.
