{ Zizala.pas                                      Copyright (c) ... }
{                                                                   }
{ Hra zizala v grafickem provedeni.                                 }
{                                                                   }
{ Author: Neznamy                                                   }
{ Date  : 18.02.2020                           http://www.trsek.com }

Program Zizala;
Uses Crt,Dos,Graph,SVGA,SBMP;

Const Max_Delka = 500;
      Esc       = #27;
      Doleva    = #75;
      Doprava   = #77;
      Nahoru    = #72;
      Dolu      = #80;

Type X_Smer   = (V,Z,S,J);
     X_Clanek = Array [1..Max_Delka] of Record
                 X : Word;
                 Y : Word;
                end;

Var Clanek,Listy,Jedy,Zdi : X_Clanek;
    Smer : X_Smer;
    Rychlost, Delka, a,b, Pocet_Listu, Pocet_Jedu, Pocet_Zdi,
    Listu, Zivoty : word;
    Key  : Char;
    Hlava,Telo,Zed,Jed,List,PodKlad,Velky_List,Velka_Hlava : Pointer;
    Ano  : Boolean;
    x,y:word;
    PathToPicture:String;

Procedure My_Exit;
Begin
 CloseGraph;
 WriteLn('Program byl ukoncen stiskem Esc');
 WriteLn('');
 WriteLn('Ukonceni probehlo bez problemu');
 Halt(1);
End;

Function IntToStr(I: Longint): String;
var
 S: string[11];
begin
 Str(I, S);
 IntToStr := S;
end;

Procedure Zvuk(Hz,D:LongInt);
 begin
  Sound(Hz);
  Delay(D);
  NoSound;
 end;

Procedure Napis(X,Y:word;P,V,C:byte;Text:String);
 begin
  SetColor(C);
  SetTextStyle(P,HorizDir,V);
  OutTextXY(X,Y,Text);
 end;

Procedure Nacti_Data;
 var paleta:RGB_Palette;
     x:byte;
 begin
  Obrazek(0,0,PathToPicture);
  GetMem(Hlava  ,ImageSize( 1,16,11,25));
  GetMem(Telo   ,ImageSize(12,16,21,25));
  GetMem(List   ,ImageSize(23,15,31,25));
  GetMem(Jed    ,ImageSize(33,15,43,25));
  GetMem(Zed    ,ImageSize(45,16,55,26));
  GetMem(PodKlad,ImageSize(55,16,65,25));
  GetMem(Velky_List,ImageSize(0,0,29,30));
  GetMem(Velka_Hlava,ImageSize(0,0,29,30));
  GetImage( 2,16,11,25,Hlava^);
  GetImage(13,16,22,25,Telo^);
  GetImage(23,15,31,25,List^);
  GetImage(33,15,43,25,Jed^);
  GetImage(44,16,54,26,Zed^);
  GetImage(55,16,64,25,PodKlad^);
  GetImage(99,1,128,31,Velky_List^);
  GetImage(160,1,185,31,Velka_Hlava^);
  ClearDevice;
 end;

Procedure Hraci_Pole;
 var OK:Boolean;
 begin

  For a:=1 to 62 do PutImage(a*10,0,Zed^,NormalPut);
  For a:=1 to 40 do
      begin
       PutImage(10,a*10,Zed^,NormalPut);
       PutImage(620,a*10,Zed^,NormalPut);
      end;
  For a:=1 to 62 do PutImage(a*10,400,Zed^,NormalPut);

  For b:=1 to 39 do
      For a:=2 to 61 do PutImage(a*10,b*10,PodKlad^,NormalPut);

  For a:=1 to Pocet_Zdi do
      begin
       PutImage(Zdi[a].X,Zdi[a].Y,Zed^,NormalPut);
      end;

  For a:=1 to Pocet_Listu do
      begin
       Repeat
        OK:=True;
        Listy[a].X:=(Round(Random(60))*10)+20;
        Listy[a].Y:=(Round(Random(38))*10)+20;
        For b:=1 to a-1 do
         If (Listy[b].X=Listy[a].X) and (Listy[b].Y=Listy[a].Y) then OK:=False;
        until OK;
       PutImage(Listy[a].X,Listy[a].Y,List^,AndPut);
      end;

  For a:=1 to Pocet_Jedu do
      begin
       Repeat
        OK:=True;
        Jedy[a].X:=(Round(Random(60))*10)+20;
        Jedy[a].Y:=(Round(Random(38))*10)+20;
        For b:=1 to a-1 do
         If (Jedy[b].X=Jedy[a].X) and (Jedy[b].Y=Jedy[a].Y)
            then OK:=False;
        For b:=1 to Pocet_Listu do
         If (Listy[b].X=Jedy[a].X) and (Listy[b].Y=Jedy[a].Y)
            then OK:=False;
        until OK;
       PutImage(Jedy[a].X,Jedy[a].Y,Jed^,AndPut);
      end;
  PutImage(10,418,Velky_List^,NormalPut);
  Napis(60,420,DefaultFont,4,127,IntToStr(Listu));
  PutImage(607,418,Velka_Hlava^,NormalPut);
  Napis(570,420,DefaultFont,4,127,IntToStr(Zivoty));
 end;

Procedure Cas;
  var hodina,minuta,sekunda,sek100: word;
  begin
   GetTime(hodina,minuta,sekunda,sek100);
   GoToXY (35,24);
   Write (' ',Hodina,':',Minuta,':',Sekunda,':',Sek100,' ');
  end;


Procedure Nakresli_Zizalu;
 begin
   For a:=Delka+1 downto 2 do
        begin
         If (a>1) and (a<Delka+1) then PutImage(Clanek[a].X,Clanek[a].Y+1,Telo^,NormalPut);
         If a=(Delka+1) then PutImage(Clanek[a].X,Clanek[a].Y+1,Podklad^,NormalPut);
        end;
   PutImage(Clanek[1].X,Clanek[1].Y+1,Hlava^,NormalPut);
 end;

Procedure Vypocitej_Posun;
 begin
  For a:=Delka+1 downto 2 do
       begin
        Clanek[a].X:=Clanek[a-1].X;
        Clanek[a].Y:=Clanek[a-1].Y;
       end;
 end;
Procedure Do_Zdi;
 begin
   Napis(400,420,DefaultFont,2,255,'Pozor zed');
   Sound(1000);Delay(200);NoSound;
   Napis(400,420,DefaultFont,2,Black,'Pozor zed');
   Napis(570,420,DefaultFont,4,Black,IntToStr(Zivoty));
   If Zivoty>0 then Zivoty:=Zivoty-1;
   Napis(570,420,DefaultFont,4,127,IntToStr(Zivoty));
   If Zivoty>0 then
    begin
      PutImage(Clanek[1].X,Clanek[1].Y+1,Podklad^,NormalPut);
      For a:=2 to Delka+1 do
           PutImage(Clanek[a].X,Clanek[a].Y,Podklad^,NormalPut);
     For a:=1 to Delka+1 do
       begin
        Clanek[a].X:=350;
        Clanek[a].Y:=200;
       end;
     PutImage(Clanek[1].X,Clanek[1].Y+1,Hlava^,NormalPut);
     Repeat
      If Keypressed then Key:=ReadKey;
     Until (Key=Doleva) or (Key=Doprava) or (Key=Dolu) or
           (Key=Nahoru) or (Key=Esc);
      Case Key of
       Doprava: Smer:=Z;
       Doleva : Smer:=V;
       Nahoru : Smer:=S;
       Dolu   : Smer:=J;
      End;
     PutImage(Clanek[1].X,Clanek[1].Y+1,Podklad^,NormalPut);
     Vypocitej_Posun;
     Case Smer of
     V:Clanek[1].X:=Clanek[1].X-10;
     Z:Clanek[1].X:=Clanek[1].X+10;
     S:Clanek[1].Y:=Clanek[1].Y-10;
     J:Clanek[1].Y:=Clanek[1].Y+10;
    End;
     Nakresli_Zizalu;
   end;
 end;
Procedure Pohyb_Zizaly;
 begin
   { Pohyb zizaly }
   Case Smer of
    V:If Clanek[1].X>20  then Clanek[1].X:=Clanek[1].X-10
                         else Do_Zdi;
    Z:If Clanek[1].X<610 then Clanek[1].X:=Clanek[1].X+10
                         else Do_Zdi;
    S:If Clanek[1].Y>10  then Clanek[1].Y:=Clanek[1].Y-10
                         else Do_Zdi;
    J:If Clanek[1].Y<390 then Clanek[1].Y:=Clanek[1].Y+10
                         else Do_Zdi;
    End;
 end;

Procedure Cti_Klavesy;
 begin
  Ano:=False;
  Key:=chr(250);
  For a:=1 to 10 do
      begin
       delay(Rychlost);
       If Keypressed and not Ano then
          begin
           Key:=ReadKey;
           If (Key=Doleva) or (Key=Doprava) or (Key=Nahoru) or (Key=Dolu) or
              (Key='+') or (Key='-') or (Key=Esc)
              then
               If (((Smer=V) and (Key=Doleva)) or
                  ((Smer=Z) and (Key=Doprava)) or
                  ((Smer=S) and (Key=Nahoru)) or
                  ((Smer=J) and (Key=Dolu)))
                  then Ano:=False
                  else Ano:=True;
             end;
      end;
   Case Key of
    Doprava: Smer:=Z;
    Doleva : Smer:=V;
    Nahoru : Smer:=S;
    Dolu   : Smer:=J;
    '+'    : Rychlost:=Rychlost-1;
    '-'    : Rychlost:=Rychlost+1;
    End;
 end;

Procedure Zjisti_kde_jsi;
 begin
  For a:=1 to Pocet_Listu do
       begin
        If (Clanek[1].X=Listy[a].X) and (Clanek[1].Y=Listy[a].Y) then
           begin
            Clanek[Delka+2].X:=Clanek[Delka+1].X;
            Clanek[Delka+2].Y:=Clanek[Delka+1].Y;
            Clanek[Delka+3].X:=Clanek[Delka+1].X;
            Clanek[Delka+3].Y:=Clanek[Delka+1].Y;
            Delka:=Delka+2;
            Listy[a].X:=0;Listy[a].Y:=0;
            If Listu>1 then Listu:=Listu-1
                       else
                           begin
                            Listu:=Listu-1;
                           end;
            SetFillStyle(0,15);
            Bar(60,420,152,450);
            Napis(60,420,DefaultFont,4,127,IntToStr(Listu));
            Zvuk(100,10);
           end;
       end;
   For a:=1 to Pocet_Jedu do
       begin
        If (Clanek[1].X=Jedy[a].X) and (Clanek[1].Y=Jedy[a].Y) then
           begin
            Jedy[a].X:=0;Jedy[a].Y:=0;
            Napis(300,420,DefaultFont,1,17,'To je jed');
            Zvuk(1000,200);
            Napis(570,420,DefaultFont,4,Black,IntToStr(Zivoty));
            If Zivoty>0 then Zivoty:=Zivoty-1;
            Napis(570,420,DefaultFont,4,127,IntToStr(Zivoty));
            SetFillStyle(0,15);
            Bar(300,420,400,440);
            Zvuk(20,500);
           end;
       end;
  For a:=2 to delka do
      begin
       If (Clanek[1].X=Clanek[a].X) and (Clanek[1].Y=Clanek[a].Y) then
          begin
           Napis(300,420,DefaultFont,2,255,'Auvajs');
           Zvuk(2000,200);
           SetFillStyle(0,15);
           Bar(300,420,400,440);
          end;
      end;
 end;

Procedure Menu;

 Var Konec:Boolean;

 Begin
  Ano:=False; Konec:=False;
  Key:=#0;
  RectAngle(219,99,421,301);
  SetFillStyle(0,0);
  Bar(220,100,420,300);
  Napis(250,120,DefaultFont,2,255,'Hraj');
  Repeat
  Repeat
   If Keypressed then Key:=ReadKey;
  Until (Key=Doleva) or (Key=Doprava) or (Key=Dolu) or
        (Key=Nahoru) or (Key=Esc);
  If Key=Esc then
     begin
      My_Exit;
     end;
  Until Konec;
End; { Konec procedury Menu }


BEGIN

 Randomize;       { Aktivace generatoru nahodnych cisel }
 PathToPicture:='zizala.bmp';
 PathToDriver:='';
 Otevri;          { Otevri graficky mod 640x480x256 }
 Nacti_Data;      { Nacteni obrazku : hlava, telo, ... }
 Pocet_Listu:=100;
 Listu:=100;
 Pocet_Jedu:=80;
 Zivoty:=3;
 Hraci_Pole;      { Nakresli hrace pole }
 Smer:=V;         { Prirazeni zkladneho smeru }
 Rychlost:=20;
 Delka:=1;
 For a:=1 to 2 do
     begin
      Clanek[a].X:=350;
      Clanek[a].Y:=200;
     end;
 PutImage(Clanek[1].X,Clanek[1].Y+1,Hlava^,NormalPut);
 Repeat
  If Keypressed then Key:=ReadKey;
 Until (Key=Doleva) or (Key=Doprava) or (Key=Dolu) or
       (Key=Nahoru) or (Key=Esc);
 Case Key of
    Doprava: Smer:=Z;
    Doleva : Smer:=V;
    Nahoru : Smer:=S;
    Dolu   : Smer:=J;
 End;
 PutImage(Clanek[1].X,Clanek[1].Y+1,Podklad^,NormalPut);

 { Hlavny cyklus }
 Repeat

 Repeat

   Key:=' ';

   Nakresli_Zizalu;
   Vypocitej_Posun;
   Cti_Klavesy;

   Pohyb_Zizaly;

   Zjisti_kde_Jsi; { Narazy do zdi, jedu... }
   PutImage(Clanek[1].X,Clanek[1].Y+1,Hlava^,NormalPut);

 Until (Key=Esc) or (Zivoty=0) or (Listu=0);
 Menu;
 Until Ano;
 CloseGraph { Uzavri grafiku }
END.
